terraform cli installation
https://developer.hashicorp.com/terraform/tutorials/aws-get-started/install-cli

sudo apt-get update && sudo apt-get install -y gnupg software-properties-common
wget -O- https://apt.releases.hashicorp.com/gpg | \
    gpg --dearmor | \
    sudo tee /usr/share/keyrings/hashicorp-archive-keyring.gpg
gpg --no-default-keyring \
    --keyring /usr/share/keyrings/hashicorp-archive-keyring.gpg \
    --fingerprint
echo "deb [signed-by=/usr/share/keyrings/hashicorp-archive-keyring.gpg] \
    https://apt.releases.hashicorp.com $(lsb_release -cs) main" | \
    sudo tee /etc/apt/sources.list.d/hashicorp.list
sudo apt update
sudo apt-get install terraform
verify 
terraform -help
terraform -install-autocomplete

provider "aws"{
    region = "eu-central-1"
    profile = "default"
 
}

terraform init
terraform apply
terraform plan
terraform destroy -target aws_subnet.sample_subnet
terraform apply -auto-approve


define a data fetch from existing resources:

data "aws_vpc" "existing_vpc"{
    default=true
}



will delete everything
terraform destroy 
this gives us current state :
 terraform.tfstate

list current state :
terraform state list
terraform state show aws_subnet.sample_subnet

output
output "my_vpc_id"{
    value=aws_vpc.sample_vpc.id
}
output "subnet_arn"{
    value = aws_subnet.sample_subnet.arn
}
define variable
variable "subnet_cidr"{
    description = "subnet cidr"
}

variable "subnet_cidr"{
    description = "subnet cidr"
    default="172.35.32.0/20"
}

variable "subnet_cidr"{
    description = "subnet cidr"
    type = string
}
# in case of array
resource "aws_subnet" "sample_subnet"{
    cidr_block = var.subnet_cidr[1]
    vpc_id = aws_vpc.sample_vpc.id
    availability_zone = "eu-central-1a"
 
}
# object list varible
variable "subnet_cidr1"{
    description = "subnet cidr"
    type = list(object({
        cidr_block=string
        name=string
    }))
}
value for above
subnet_cidr1=[{cidr_block="172.32.32.0/20" , name="fresh"}]      

to set environmental variables:
export TF_VAR_AWS_ZONE="eu-central-1a"
in terrform file:
variable AWS_ZONE{}


terraform apply -var "subnet_cidr=172.35.32.0/20"

terraform apply -var-file terraform-dev.tfvars

